searchData={"items":[{"type":"module","title":"Wongi.Engine","doc":"A forward-chaining inference engine for Elixir.\n\nA port of the Ruby library with the same name.","ref":"Wongi.Engine.html"},{"type":"function","title":"Wongi.Engine.assert/2","doc":"Returns an engine with the given fact added to the working memory.","ref":"Wongi.Engine.html#assert/2"},{"type":"function","title":"Wongi.Engine.assert/4","doc":"Returns an engine with the given fact added to the working memory.","ref":"Wongi.Engine.html#assert/4"},{"type":"function","title":"Wongi.Engine.compile/2","doc":"Returns an engine with the given rule installed.\n\nSee `Wongi.Engine.DSL` for details on the rule definition DSL.","ref":"Wongi.Engine.html#compile/2"},{"type":"function","title":"Wongi.Engine.compile_and_get_ref/2","doc":"Returns an engine with the given rule installed and the rule reference.\n\nThe rule reference can be used to retrieve production tokens using `tokens/2`.\n\nSee `Wongi.Engine.DSL` for details on the rule definition DSL.","ref":"Wongi.Engine.html#compile_and_get_ref/2"},{"type":"function","title":"Wongi.Engine.entity/2","doc":"","ref":"Wongi.Engine.html#entity/2"},{"type":"function","title":"Wongi.Engine.new/0","doc":"Creates a new engine instance.","ref":"Wongi.Engine.html#new/0"},{"type":"function","title":"Wongi.Engine.productions/1","doc":"Returns all production node references.","ref":"Wongi.Engine.html#productions/1"},{"type":"function","title":"Wongi.Engine.retract/2","doc":"Returns an engine with the given fact removed from the working memory.","ref":"Wongi.Engine.html#retract/2"},{"type":"function","title":"Wongi.Engine.retract/4","doc":"Returns an engine with the given fact removed from the working memory.","ref":"Wongi.Engine.html#retract/4"},{"type":"function","title":"Wongi.Engine.select/2","doc":"Returns a set of all facts matching the given template.","ref":"Wongi.Engine.html#select/2"},{"type":"function","title":"Wongi.Engine.select/4","doc":"Returns a set of all facts matching the given template.","ref":"Wongi.Engine.html#select/4"},{"type":"function","title":"Wongi.Engine.tokens/2","doc":"Returns a set of all tokens for the given production node reference.","ref":"Wongi.Engine.html#tokens/2"},{"type":"type","title":"Wongi.Engine.fact/0","doc":"","ref":"Wongi.Engine.html#t:fact/0"},{"type":"opaque","title":"Wongi.Engine.rule/0","doc":"","ref":"Wongi.Engine.html#t:rule/0"},{"type":"opaque","title":"Wongi.Engine.t/0","doc":"","ref":"Wongi.Engine.html#t:t/0"},{"type":"type","title":"Wongi.Engine.template/0","doc":"","ref":"Wongi.Engine.html#t:template/0"},{"type":"opaque","title":"Wongi.Engine.wme/0","doc":"","ref":"Wongi.Engine.html#t:wme/0"},{"type":"module","title":"Wongi.Engine.Aggregates","doc":"Aggregate helpers.","ref":"Wongi.Engine.Aggregates.html"},{"type":"function","title":"Wongi.Engine.Aggregates.max/1","doc":"","ref":"Wongi.Engine.Aggregates.html#max/1"},{"type":"function","title":"Wongi.Engine.Aggregates.min/1","doc":"","ref":"Wongi.Engine.Aggregates.html#min/1"},{"type":"function","title":"Wongi.Engine.Aggregates.product/1","doc":"","ref":"Wongi.Engine.Aggregates.html#product/1"},{"type":"function","title":"Wongi.Engine.Aggregates.sum/1","doc":"","ref":"Wongi.Engine.Aggregates.html#sum/1"},{"type":"module","title":"Wongi.Engine.DSL","doc":"Rule definition functions.","ref":"Wongi.Engine.DSL.html"},{"type":"function","title":"Wongi.Engine.DSL.aggregate/3","doc":"","ref":"Wongi.Engine.DSL.html#aggregate/3"},{"type":"function","title":"Wongi.Engine.DSL.any/0","doc":"Placeholder variable. Synonym for `:_`.","ref":"Wongi.Engine.DSL.html#any/0"},{"type":"function","title":"Wongi.Engine.DSL.any/1","doc":"A matcher that passes if any of the sub-chains passes.","ref":"Wongi.Engine.DSL.html#any/1"},{"type":"function","title":"Wongi.Engine.DSL.assign/2","doc":"","ref":"Wongi.Engine.DSL.html#assign/2"},{"type":"function","title":"Wongi.Engine.DSL.diff/2","doc":"","ref":"Wongi.Engine.DSL.html#diff/2"},{"type":"function","title":"Wongi.Engine.DSL.equal/2","doc":"","ref":"Wongi.Engine.DSL.html#equal/2"},{"type":"function","title":"Wongi.Engine.DSL.fact/4","doc":"Synonym for `has/3`, `has/4`.","ref":"Wongi.Engine.DSL.html#fact/4"},{"type":"function","title":"Wongi.Engine.DSL.filter/1","doc":"","ref":"Wongi.Engine.DSL.html#filter/1"},{"type":"function","title":"Wongi.Engine.DSL.gen/3","doc":"","ref":"Wongi.Engine.DSL.html#gen/3"},{"type":"function","title":"Wongi.Engine.DSL.greater/2","doc":"","ref":"Wongi.Engine.DSL.html#greater/2"},{"type":"function","title":"Wongi.Engine.DSL.gte/2","doc":"","ref":"Wongi.Engine.DSL.html#gte/2"},{"type":"function","title":"Wongi.Engine.DSL.has/4","doc":"A matcher that passes if the specified fact is present in the working memory.","ref":"Wongi.Engine.DSL.html#has/4"},{"type":"function","title":"Wongi.Engine.DSL.in_list/2","doc":"","ref":"Wongi.Engine.DSL.html#in_list/2"},{"type":"function","title":"Wongi.Engine.DSL.less/2","doc":"","ref":"Wongi.Engine.DSL.html#less/2"},{"type":"function","title":"Wongi.Engine.DSL.lte/2","doc":"","ref":"Wongi.Engine.DSL.html#lte/2"},{"type":"function","title":"Wongi.Engine.DSL.missing/3","doc":"Synonym for `neg/3`.","ref":"Wongi.Engine.DSL.html#missing/3"},{"type":"function","title":"Wongi.Engine.DSL.ncc/1","doc":"A matcher that passes if the sub-chain does not pass.","ref":"Wongi.Engine.DSL.html#ncc/1"},{"type":"function","title":"Wongi.Engine.DSL.neg/3","doc":"A matcher that passes if the specified fact is not present in the working memory.","ref":"Wongi.Engine.DSL.html#neg/3"},{"type":"function","title":"Wongi.Engine.DSL.none/1","doc":"Synonym for `ncc/1`.","ref":"Wongi.Engine.DSL.html#none/1"},{"type":"function","title":"Wongi.Engine.DSL.not_in_list/2","doc":"","ref":"Wongi.Engine.DSL.html#not_in_list/2"},{"type":"function","title":"Wongi.Engine.DSL.rule/2","doc":"","ref":"Wongi.Engine.DSL.html#rule/2"},{"type":"function","title":"Wongi.Engine.DSL.var/1","doc":"Variable declaration.","ref":"Wongi.Engine.DSL.html#var/1"},{"type":"type","title":"Wongi.Engine.DSL.action/0","doc":"","ref":"Wongi.Engine.DSL.html#t:action/0"},{"type":"type","title":"Wongi.Engine.DSL.matcher/0","doc":"","ref":"Wongi.Engine.DSL.html#t:matcher/0"},{"type":"opaque","title":"Wongi.Engine.DSL.rule/0","doc":"","ref":"Wongi.Engine.DSL.html#t:rule/0"},{"type":"type","title":"Wongi.Engine.DSL.rule_option/0","doc":"","ref":"Wongi.Engine.DSL.html#t:rule_option/0"},{"type":"protocol","title":"Wongi.Engine.DSL.Clause","doc":"Rule matcher.","ref":"Wongi.Engine.DSL.Clause.html"},{"type":"function","title":"Wongi.Engine.DSL.Clause.compile/2","doc":"","ref":"Wongi.Engine.DSL.Clause.html#compile/2"},{"type":"type","title":"Wongi.Engine.DSL.Clause.t/0","doc":"All the types that implement this protocol.","ref":"Wongi.Engine.DSL.Clause.html#t:t/0"},{"type":"module","title":"Wongi.Engine.DSL.Has","doc":"Positive assertion.","ref":"Wongi.Engine.DSL.Has.html"},{"type":"type","title":"Wongi.Engine.DSL.Has.option/0","doc":"","ref":"Wongi.Engine.DSL.Has.html#t:option/0"},{"type":"module","title":"Wongi.Engine.DSL.Var","doc":"Variable declaration.","ref":"Wongi.Engine.DSL.Var.html"},{"type":"type","title":"Wongi.Engine.DSL.Var.t/0","doc":"","ref":"Wongi.Engine.DSL.Var.html#t:t/0"},{"type":"protocol","title":"Wongi.Engine.Filter","doc":"Filters tokens based on a predicate.","ref":"Wongi.Engine.Filter.html"},{"type":"function","title":"Wongi.Engine.Filter.pass?/2","doc":"","ref":"Wongi.Engine.Filter.html#pass?/2"},{"type":"type","title":"Wongi.Engine.Filter.t/0","doc":"All the types that implement this protocol.","ref":"Wongi.Engine.Filter.html#t:t/0"},{"type":"module","title":"Wongi.Engine.Token","doc":"An intermediate data structure representing a partial match.","ref":"Wongi.Engine.Token.html"},{"type":"function","title":"Wongi.Engine.Token.fetch/2","doc":"Returns the value of a bound variable.","ref":"Wongi.Engine.Token.html#fetch/2"},{"type":"type","title":"Wongi.Engine.Token.t/0","doc":"","ref":"Wongi.Engine.Token.html#t:t/0"}],"content_type":"text/markdown"}